//AllesEntsperren_504d.js
// 26.04.15 / Hans Haesler, Chtelard 52, CH-1018 Lausanne / <hsa@ringier.ch>
//DESCRIPTION:Sperrungen aufheben

// vorbeugenderweise das Anzeigen von Dialogen aktivieren
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// prfen, ob ein Dokument geffnet ist
if (app.documents.length == 0) {
	alert ("Es ist kein Dokument offen.", "Achtung");
	exit();
}

// die Funktion aufrufen, welche die gespeicherten Vorgaben einliest
var allPrefs  = getPrefs();
if (allPrefs != "") {
	var prefVal = allPrefs.split("\n");
	var rVal1   = prefVal[0];
	var cVal1   = prefVal[1];
	var rVal2   = prefVal[2];
	var pNum    = prefVal[3];
	rb02 = rb05 = 1;
	rb01 = rb03 = rb04 = rb06 = 0;
	if (rVal1  == "0") {
		rb01 = 1;
		rb02 = 0;
	}
	else if (rVal1 == "2") {
		rb02 = 0;
		rb03 = 1;
	}
	else if (rVal1 == "3") {
		rb02 = 0;
		rb04 = 1;
	}
	ck01 = 1;
	if (cVal1  == "false") { ck01 = 0; }
	if (rVal2  == "1") {
		rb05 = 0;
		rb06 = 1;
	}
}
else {
	// wenn die Prferenzen-Datei nicht gefunden wurde, 
	// auf die folgenden Vorgabenwerte zurckgreifen
	rb01 =  0;
	rb02 =  1;
	rb03 =  0;
	rb04 =  0;
	ck01 =  0;
	rb05 =  1;
	rb06 =  0;
	pNum = "";
}
// den Dialog zum Entscheiden anzeigen
var userDec = askUser1();
// den Variablen das Ergebnis zuweisen
docuRge = userDec[0];
actLayr = userDec[1];
anchObj = userDec[2];
if (actLayr == true) {
	var layName = app.activeWindow.activeLayer.name;
}

// je nach Wunsch die Aktion auslsen
if (docuRge == 0) { // "Die ausgewhlten Rahmen"
	var selFrames = app.selection;
	if (selFrames.length == 0) {
		alert ("Es ist nichts ausgewhlt.", "Stop");
		exit();
	}
	for (var i=0; i<selFrames.length; i++) {
		var curFrame = selFrames[i];
		if (actLayr == false) {
			unLockOne(curFrame);
		}
		else {
			if (curFrame.itemLayer.name == layName) {
				unLockOne(curFrame);
			}
		}
		allFrames = curFrame.allPageItems;
		if (allFrames.length > 0) {
			for (var k=0; k<allFrames.length; k++) {
				if (actLayr == false) {
					unLockOne(allFrames[k]);
				}
				else {
					if (allFrames[k].itemLayer.name == layName) {
						unLockOne(allFrames[k]);
					}
				}
			}
		}
	}
}
else if (docuRge == 1) { // "Auf dem aktuellen Druckbogen"
	var allFrames = app.activeWindow.activeSpread.allPageItems;
	if (actLayr == false) {
		unLockAll(allFrames);
	}
	else {
		unLockLayr(layName, allFrames);
	}
}
else if (docuRge == 2) { // "In einem bestimmten Seitenbereich"
	var curDoc = app.documents[0];
	// prfen, ob Abschnitts-Prfizes definiert sind
	sectPrefs = false;
	var allPrefNames = new Array();
	for (var p=0; p<curDoc.pages.length; p++) {
		var curSect = curDoc.pages[p].appliedSection.name;
		allPrefNames.push(curSect);
	}
	var testString = allPrefNames.join("");
	if (testString.length > 0) {
		sectPrefs = true;
	}
	// die Liste der Seitennummern
	if (sectPrefs == false) {
		allPageNames = curDoc.pages.everyItem().name;
	}
	else {
		var allPageNames = new Array();
		for (var p=0; p<curDoc.pages.length; p++) {
			var curName = curDoc.pages[p].name;
			allPageNames.push(allPrefNames[p] + curName);
		}
	}
	// den Dialog zum Eingeben des Seitenbereichs aufrufen
	var pageRange = askUser2();
	// die Eingabe prfen lassen
	if (sectPrefs == false) {
		allPages = rangeNoSectPref(pageRange);
	}
	else {
		allPages = rangeWithSectPref(pageRange);
	}	
	// eine Schleife durch die Seiten
	for (var p=0; p<allPages.length; p++) {
		var allFrames = app.documents[0].pages[allPages[p]].allPageItems;
		if (actLayr == false) {
			unLockAll(allFrames);
		}
		else {
			unLockLayr(layName, allFrames);
		}
	}
}
else if (docuRge == 3) { // "Im ganzen Dokument"
	if (actLayr == false) {
		var allFrames = app.documents[0].allPageItems;
	}
	else {
		var allFrames = app.activeWindow.activeLayer.allPageItems;
	}
	unLockAll(allFrames);
}

// die Liste der Einstellungen ...
var prefsList = new Array(docuRge, actLayr, anchObj, pageRange);
// ... in eine Textkette verwandeln ...
var prefString = prefsList.join("\n");
// ... zur Funktion schicken, welche sie in eine Datei schreibt ...
writeResult(prefString);

// das Ende der Aktion verknden
var dlog = new Window("palette");
dlog.size = [320,100];
dlog.add("statictext", [80, 100, 320, 116], "Fertig.");
dlog.show();
// eine kleine Pause
$.sleep(1500);
// das Fenster schliessen
dlog.close();


////////////////////////////// die Funktionen  ////////////////////////////////////////////////////

// die Funktion, welche die Informationen vorbereitet /////////////////////////////////////////////
function getPrefs() {
	var allPrefs = "";
	// die Datei lesen, welche die gespeicherten Werte enthlt
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/AllesEntsperren504.txt");
	}
	else {
		var f = new File("~/Library/Preferences/AllesEntsperren504.txt");
	}
	var fileIsOpen = f.open("r");
	if (fileIsOpen) {
		try {
			allPrefs = f.read();
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
	return allPrefs;
}

// den ersten Entscheidungs-Dialog vorbereiten und anzeigen ///////////////////////////////////////
function askUser1() {
	try {
		app.dialogs.everyItem().destroy();
	}
	catch (e) {
	}
	var labelWidth0 = 16;
	var labelWidth1 =  4;
	var labelWidth2 = 88;
	var aDialog = app.dialogs.add({name:"AllesEntsperren"});
	with (aDialog) {
		with (dialogColumns.add()) {
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:" ", minWidth:labelWidth0});
				staticTexts.add({staticLabel:"Was (oder wo) soll entsperrt werden?"});
				staticTexts.add({staticLabel:" ", minWidth:labelWidth0});
			}
			with (dialogRows.add()) {
				with (borderPanels.add()) {
					with (dialogColumns.add()) {
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:" ", minWidth:labelWidth1});
							with(refButtons1 = radiobuttonGroups.add()) {
								radiobuttonControls.add({staticLabel:"Die ausgewhlten Rahmen", checkedState:rb01});
								radiobuttonControls.add({staticLabel:"Auf dem aktuellen Druckbogen", checkedState:rb02});
								radiobuttonControls.add({staticLabel:"In einem bestimmten Seitenbereich", checkedState:rb03});
								radiobuttonControls.add({staticLabel:"Im ganzen Dokument", checkedState:rb04});
							}
						}
					}
				}
			}
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:" ", minWidth:labelWidth0});
				var checkbox01 = checkboxControls.add({staticLabel:"Auf der aktiven Ebene", checkedState:ck01, minWidth:labelWidth2});
			}
			with (dialogRows.add()) {
				with (borderPanels.add()) {
					with (dialogColumns.add()) {
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:" ", minWidth:labelWidth1});
							staticTexts.add({staticLabel:"Verankerte Rahmen ..."});
							staticTexts.add({staticLabel:" ", minWidth:labelWidth0});
						}
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:" ", minWidth:labelWidth1});
							with(refButtons2 = radiobuttonGroups.add()) {
								radiobuttonControls.add({staticLabel:"gesperrt lassen", checkedState:rb05});
								radiobuttonControls.add({staticLabel:"ebenfalls entsperren", checkedState:rb06});
							}
							staticTexts.add({staticLabel:" ", minWidth:labelWidth2});
						}
					}
				}
			}
		}
		with (dialogColumns.add()) {
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:" ", minWidth:4});
			}
		}
	}
	if(aDialog.show() == true) {
		var refDec1 = refButtons1.selectedButton;
		var check01 = checkbox01.checkedState;
		var refDec2 = refButtons2.selectedButton;
		// den Dialog entfernen
		aDialog.destroy();
		// die Werte zurckschicken
		return [refDec1, check01, refDec2];
	}
	else {
		aDialog.destroy();
		exit();
	}
}

// den zweiten Dialog vorbereiten und anzeigen ////////////////////////////////////////////////////
function askUser2() {
	var fieldWidth  = 350;
	var aDialog = app.dialogs.add({name:"AllesEntsperren"});
	with (aDialog) {
		with (dialogColumns.add()) {
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:"Seitenbereich(e) eingeben (z.B. 1, 2-3, 4-7, 8):"});
				staticTexts.add({staticLabel:" ", minWidth:10});
			}
			with (dialogRows.add()) {
				var pagesField = textEditboxes.add({editContents:pNum, minWidth:fieldWidth});
			}
		}
		with (dialogColumns.add()) {
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:" ", minWidth:4});
			}
		}
	}
	if(aDialog.show() == true) {
		pNum = pagesField.editContents;
		// den Dialog entfernen
		aDialog.destroy();
		// ... und nach der Prfung ...
		if (pNum == "") {
			alert ("Seitenbereich(e):\n\nDas Eingabefeld ist leer.", "Stop");
			exit();
		}
		// ... ebenfalls zurck zum Aufruf
		return pNum;
	}
	else {
		aDialog.destroy();
		exit();
	}
}

// die Liste der Seitenzahlen aufstellen und prfen ///////////////////////////////////////////////
function rangeNoSectPref(pageRange) {  // wenn keine Abschnittsprfizes definiert sind ////////////
	var whatKind = 0;
	var pagesList = new Array();
	var indList   = new Array();
	// Leerschlge entfernen
	var newRange = pageRange.split(" ");
	newRange = newRange.join("");
	// prfen, ob Kommas und/oder Bindestriche und/oder Pluszeichen enthalten sind
	if (newRange.indexOf("-") != -1) {
		whatKind = whatKind + 1;
	}
	if (newRange.indexOf(",") != -1) {
		whatKind = whatKind + 2;
	}
	if (newRange.indexOf("+") != -1) {
		whatKind = whatKind + 4;
	}
	// je nach Art der Kette die Listen erstellen
	if (whatKind == 0) {
		pagesList.push(newRange);
	}
	else if (whatKind == 1) {
		var newRangeList = newRange.split("-");
		var startVal = newRangeList[0]*1;
		var stopVal  = (newRangeList[1]*1);
		if (startVal<stopVal) {
			for (var i=startVal; i<stopVal+1; i++) {
				pagesList.push(""+i);
			}
		}
		else {
			for (var i=stopVal; i<startVal+1; i++) {
				pagesList.push(""+i);
			}
		}
	}
	else if (whatKind == 2) {
		var newRangeList = newRange.split(",");
		for (var i=0; i<newRangeList.length; i++) {
			pagesList.push(newRangeList[i]);
		}
	}
	else if (whatKind == 3) {
		var newRangeList = newRange.split(",");
		for (var i=0; i<newRangeList.length; i++) {
			var tmpItem = newRangeList[i];
			if (tmpItem.indexOf("-") != -1) {
				var tmpItemList = tmpItem.split("-");
				var startVal = tmpItemList[0]*1;
				var stopVal  = (tmpItemList[1]*1);
				if (startVal<stopVal) {
					for (var k=startVal; k<stopVal+1; k++) {
						pagesList.push(""+k);
					}
				}
				else {
					for (var k=stopVal; k<startVal+1; k++) {
						pagesList.push(""+k);
					}
				}
			}
			else {
				pagesList.push(newRangeList[i]);
			}
		}
	}
	else if (whatKind == 4) {
		indList.push((newRange*1)-1);
	}
	else if (whatKind == 5) {
		var newRangeList = newRange.split("-");
		var startVal = (newRangeList[0]*1);
		var stopVal  = (newRangeList[1]*1);
		if (startVal<stopVal) {
			for (var i=startVal-1; i<stopVal; i++) {
				indList.push(i);
			}
		}
		else {
			for (var i=stopVal-1; i<startVal; i++) {
				indList.push(i);
			}
		}
	}
	else if (whatKind == 6) {
		var newRangeList = newRange.split(",");
		for (var i=0; i<newRangeList.length; i++) {
			if (newRangeList[i][0] == "+") {
				indList.push((newRangeList[i]*1)-1);
			}
			else {
				var okay = false;
				for (var k=0; k<allPageNames.length; k++) {
					if (newRangeList[i] == allPageNames[k]) {
						indList.push(k);
						okay = true;
						break;
					}
				}
				if (!okay) {
					alert ("Die Seite " + newRangeList[i] + " ist nicht vorhanden.", "Stop");
					exit();
				}
			}
		}
	}
	else if (whatKind == 7) {
		var newRangeList = newRange.split(",");
		for (var i=0; i<newRangeList.length; i++) {
			var tmpItem = newRangeList[i];
			if (tmpItem.indexOf("-") != -1) {
				var tmpItemList = tmpItem.split("-");
				var startVal = (tmpItemList[0]*1);
				var stopVal  = (tmpItemList[1]*1);
				if (startVal<stopVal) {
					for (var k=startVal-1; k<stopVal; k++) {
						indList.push(k);
					}
				}
				else {
					for (var k=stopVal-1; k<startVal; k++) {
						indList.push(k);
					}
				}
			}
			else {
				if (newRangeList[i][0] == "+") {
					indList.push((newRangeList[i]*1)-1);
				}
				else {
					var okay = false;
					for (var k=0; k<allPageNames.length; k++) {
						if (newRangeList[i] == allPageNames[k]) {
							indList.push(k);
							okay = true;
							break;
						}
					}
					if (!okay) {
						alert ("Die Seite " + newRangeList[i] + " ist nicht vorhanden.", "Stop");
						exit();
					}
				}
			}
		}
	}
	// prfen, ob die gewnschten Seiten existieren
	if (whatKind < 4) {
		var nNum = pagesList.length;
		for (var i=0; i<nNum; i++) {
			var okay = false;
			var actNum = pagesList[i];
			for (var k=0; k<allPageNames.length; k++) {
				if (actNum == allPageNames[k]) {
					okay = true;
					indList.push(k);
					break;
				}
			}
		}
		if (okay) {
			return indList;
		}
		else {
			alert ("Die Seite " + actNum + " ist nicht vorhanden.", "Stop");
			exit();
		}
	}
	else {
		var maxInd = (allPageNames.length)-1;
		for (var i=0; i<indList.length; i++) {
			if (indList[i] > maxInd) {
				alert ("Die Seite +" + (indList[i]+1) + " ist nicht vorhanden.", "Stop");
				exit();
			}
		}
	}
	return indList;
}

function rangeWithSectPref(pageRange) {  // wenn Abschnittsprfizes definiert sind ////////////////
	var whatKind = 0;
	var indList  = new Array();
	// Leerschlge entfernen
	var newRange = pageRange.split(" ");
	newRange = newRange.join("");
	// prfen, ob Kommas und/oder Bindestriche und/oder Pluszeichen enthalten sind
	if (newRange.indexOf("-") != -1) {
		whatKind = whatKind + 1;
	}
	if (newRange.indexOf(",") != -1) {
		whatKind = whatKind + 2;
	}
	if (newRange.indexOf("+") != -1) {
		whatKind = whatKind + 4;
	}
	// je nach Art der Kette die Liste(n) der Seiten erstellen
	if (whatKind == 0) {
		var startVal  = -1;
		for (var n=0; n<allPageNames.length; n++) {
			if (allPageNames[n] == newRange) {
				startVal = n;
				break;
			}
		}
		if (startVal != -1) {
			indList.push(n);
		}
		else {
			alert ("Die Seite " + newRange + " existiert nicht.", "Stop");
			exit();
		}
	}
	else if (whatKind == 1) {
		var startVal = -1;
		for (var n=0; n<allPageNames.length; n++) {
			if (allPageNames[n] == newRange) {
				startVal = n;
				break;
			}
		}
		if (startVal != -1) {
			indList.push(n);
		}
		else {
			var newRangeList = newRange.split("-");
			if (newRangeList.length == 2) {
				var startPage = newRangeList[0];
				var stopPage  = newRangeList[1];
			}
			else if (newRangeList.length == 3) {
				var startVal  = -1;
				var startPage = newRangeList[0];
				for (var n=0; n<allPageNames.length; n++) {
					if (allPageNames[n] == startPage) {
						startVal = n;
						break;
					}
				}
				if (startVal != -1) {
					var stopPage  = newRangeList[1]+"-"+newRangeList[2];
				}
				else {
					var startPage = newRangeList[0]+"-"+newRangeList[1];
					var stopPage  = newRangeList[2];
				}
			}
			else if (newRangeList.length == 4) {
				var startPage = newRangeList[0]+"-"+newRangeList[1];
				var stopPage  = newRangeList[2]+"-"+newRangeList[3];
			}
			var startVal  = -1;
			var stopVal   = -1;
			for (var n=0; n<allPageNames.length; n++) {
				if (allPageNames[n] == startPage) {
					startVal = n;
					break;
				}
			}
			for (var n=0; n<allPageNames.length; n++) {
				if (allPageNames[n] == stopPage) {
					stopVal = n;
					break;
				}
			}
			if (startVal == -1) {
				alert ("Die Seite " + startPage + " existiert nicht.", "Stop");
				exit();
			}
			if (stopVal == -1) {
				alert ("Die Seite " + stopPage + " existiert nicht.", "Stop");
				exit();
			}
			if (startVal<stopVal) {
				for (var i=startVal; i<stopVal+1; i++) {
					indList.push(i);
				}
			}
			else {
				for (var i=stopVal; i<startVal+1; i++) {
					indList.push(i);
				}
			}
		}
	}
	else if (whatKind == 2) {
		var newRangeList = newRange.split(",");
		var startPage = newRangeList[0];
		var stopPage  = newRangeList[1];
		var startVal  = -1;
		var stopVal   = -1;
		for (var n=0; n<allPageNames.length; n++) {
			if (allPageNames[n] == startPage) {
				startVal = n;
				indList.push(n);
				break;
			}
		}
		for (var n=0; n<allPageNames.length; n++) {
			if (allPageNames[n] == stopPage) {
				stopVal = n;
				indList.push(n);
				break;
			}
		}
		if (startVal == -1) {
			alert ("Die Seite " + startPage + " existiert nicht.", "Stop");
			exit();
		}
		if (stopVal == -1) {
			alert ("Die Seite " + stopPage + " existiert nicht.", "Stop");
			exit();
		}
	}
	else if (whatKind == 3) {
		var newRangeList = newRange.split(",");
		for (var i=0; i<newRangeList.length; i++) {
			var tmpItem = newRangeList[i];
			if (tmpItem.indexOf("-") != -1) {
				var startVal = -1;
				for (var n=0; n<allPageNames.length; n++) {
					if (allPageNames[n] == tmpItem) {
						startVal = n;
						break;
					}
				}
				if (startVal != -1) {
					startPage = tmpItem;
					stopPage  = tmpItem;
				}
				else {
					var tmpList = tmpItem.split("-");
					if (tmpList.length == 2) {
						var startPage = tmpList[0];
						var stopPage  = tmpList[1];
					}
					else if (tmpList.length == 3) {
						var startVal  = -1;
						var startPage = tmpList[0];
						for (var n=0; n<allPageNames.length; n++) {
							if (allPageNames[n] == startPage) {
								startVal = n;
								break;
							}
						}
						if (startVal != -1) {
							var stopPage  = tmpList[1]+"-"+tmpList[2];
						}
						else {
							var startPage = tmpList[0]+"-"+tmpList[1];
							var stopPage  = tmpList[2];
						}
					}
					else if (tmpList.length == 4) {
						var startPage = tmpList[0]+"-"+tmpList[1];
						var stopPage  = tmpList[2]+"-"+tmpList[3];
					}
				}
				var startVal  = -1;
				var stopVal   = -1;
				for (var n=0; n<allPageNames.length; n++) {
					if (allPageNames[n] == startPage) {
						startVal = n;
						break;
					}
				}
				for (var n=0; n<allPageNames.length; n++) {
					if (allPageNames[n] == stopPage) {
						stopVal = n;
						break;
					}
				}
				if (startVal == -1) {
					alert ("Die Seite " + startPage + " existiert nicht.", "Stop");
					exit();
				}
				if (stopVal == -1) {
					alert ("Die Seite " + stopPage + " existiert nicht.", "Stop");
					exit();
				}
				if (startVal<stopVal) {
					for (var k=startVal; k<stopVal+1; k++) {
						indList.push(k);
					}
				}
				else {
					for (var k=stopVal; k<startVal+1; k++) {
						indList.push(k);
					}
				}
			}
			else {
				var startPage = newRangeList[i];
				var startVal  = -1;
				for (var n=0; n<allPageNames.length; n++) {
					if (allPageNames[n] == startPage) {
						startVal = n;
						break;
					}
				}
				if (startVal != -1) {
					indList.push(n);
				}
				else {
					alert ("Die Seite " + startPage + " existiert nicht.", "Stop");
					exit();
				}
			}
		}
	}
	else if (whatKind == 4) {
		indList.push((newRange*1)-1);
	}
	else if (whatKind == 5) {
		var newRangeList = newRange.split("-");
		var startVal = (newRangeList[0]*1);
		var stopVal  = (newRangeList[1]*1);
		if (startVal<stopVal) {
			for (var i=startVal-1; i<stopVal; i++) {
				indList.push(i);
			}
		}
		else {
			for (var i=stopVal-1; i<startVal; i++) {
				indList.push(i);
			}
		}
	}
	else if (whatKind == 6) {
		var newRangeList = newRange.split(",");
		for (var i=0; i<newRangeList.length; i++) {
			if (newRangeList[i][0] == "+") {
				indList.push((newRangeList[i]*1)-1);
			}
			else {
				var okay = false;
				for (var k=0; k<allPageNames.length; k++) {
					if (newRangeList[i] == allPageNames[k]) {
						indList.push(k);
						okay = true;
						break;
					}
				}
				if (!okay) {
					alert ("Die Seite " + newRangeList[i] + " ist nicht vorhanden.", "Stop");
					exit();
				}
			}
		}
	}
	else if (whatKind == 7) {
		var newRangeList = newRange.split(",");
		for (var i=0; i<newRangeList.length; i++) {
			var tmpItem = newRangeList[i];
			if (tmpItem.indexOf("-") != -1) {
				var tmpItemList = tmpItem.split("-");
				var startVal = (tmpItemList[0]*1);
				var stopVal  = (tmpItemList[1]*1);
				if (startVal<stopVal) {
					for (var k=startVal-1; k<stopVal; k++) {
						indList.push(k);
					}
				}
				else {
					for (var k=stopVal-1; k<startVal; k++) {
						indList.push(k);
					}
				}
			}
			else {
				if (newRangeList[i][0] == "+") {
					indList.push((newRangeList[i]*1)-1);
				}
				else {
					var okay = false;
					for (var k=0; k<allPageNames.length; k++) {
						if (newRangeList[i] == allPageNames[k]) {
							indList.push(k);
							okay = true;
							break;
						}
					}
					if (!okay) {
						alert ("Die Seite " + newRangeList[i] + " ist nicht vorhanden.", "Stop");
						exit();
					}
				}
			}
		}
	}
	// prfen, ob die gewnschten Seiten existieren
	if (whatKind > 3) {
		var maxInd = (allPageNames.length)-1;
		for (var i=indList.length-1; i>-1; i--) {
			if (indList[i] > maxInd) {
				alert ("Die Seite +" + (indList[i]+1) + " ist nicht vorhanden.", "Stop");
				exit();
			}
		}
	}
	return indList;
}

// den aktuellen Rahmen entsperren ////////////////////////////////////////////////////////////////
function unLockOne(oneFrame) {
	if (oneFrame.parent != "[object Character]") {
		// ist der Rahmen gesperrt ...
		if (oneFrame.locked == true) {
			// ... den Rahmen entsperren
			oneFrame.locked = false;
		}
	}
	else {
		// wenn verankerte Rahmen auch entsperrt werden sollen
		if (anchObj == 1) {
			// ist der Rahmen gesperrt ...
			if (oneFrame.locked == true) {
				// ... den Rahmen entsperren
				oneFrame.locked = false;
			}
			// wenn "Manuelle Positionierung verhindern" an ist ...
			if (oneFrame.anchoredObjectSettings.lockPosition == true) {
				// ... den Haken wegklicken
				oneFrame.anchoredObjectSettings.lockPosition = false;
			}
		}
	}
}

// die Funktion zum Entsperren im ganzen Dokument /////////////////////////////////////////////////
function unLockAll(allFrames) {
	//eine Schleife durch die Rahmen
	for (var f=0; f<allFrames.length; f++) {
		var curFrame = allFrames[f];
		// prfen, ob verankert
		if (curFrame.parent != "[object Character]") {
			// ist der Rahmen gesperrt ...
			if (curFrame.locked == true) {
				// ... den Rahmen entsperren
				curFrame.locked = false;
			}
		}
		else {
			// wenn verankerte Rahmen auch entsperrt werden sollen
			if (anchObj == 1) {
				// ist der Rahmen gesperrt ...
				if (curFrame.locked == true) {
					// ... den Rahmen entsperren
					curFrame.locked = false;
				}
				// wenn "Manuelle Positionierung verhindern" an ist ...
				if (curFrame.anchoredObjectSettings.lockPosition == true) {
					// ... den Haken wegklicken
					curFrame.anchoredObjectSettings.lockPosition = false;
				}
			}
		}
	}
}

// die Funktion zum Entsperren auf der aktiven Ebene //////////////////////////////////////////////
function unLockLayr(layName, allFrames) {
	//eine Schleife durch die Rahmen
	for (var f=0; f<allFrames.length; f++) {
		var curFrame = allFrames[f];
		// der Name der Ebene prfen
		if (curFrame.itemLayer.name == layName) {
			// prfen, ob verankert
			if (curFrame.parent != "[object Character]") {
				// ist der Rahmen gesperrt ...
				if (curFrame.locked == true) {
					// ... den Rahmen entsperren
					curFrame.locked = false;
				}
			}
			else {
				// wenn verankerte Rahmen auch entsperrt werden sollen
				if (anchObj == 1) {
					// ist der Rahmen gesperrt ...
					if (curFrame.locked == true) {
						// ... den Rahmen entsperren
						curFrame.locked = false;
					}
					// wenn "Manuelle Positionierung verhindern" an ist ...
					if (curFrame.anchoredObjectSettings.lockPosition == true) {
						// ... den Haken wegklicken
						curFrame.anchoredObjectSettings.lockPosition = false;
					}
				}
			}
		}
	}
}

// das Ergebnis in eine Datei schreiben ///////////////////////////////////////////////////////////
function writeResult(curPrefs) {
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/AllesEntsperren504.txt");
	}
	else {
		var f = new File("~/Library/Preferences/AllesEntsperren504.txt");
	}
	var fileIsOpen = f.open("w");
	if (fileIsOpen) {
		try {
			f.write(curPrefs);
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
}